Subject: Re: Next 14: s390x defconfig build failure

From: David Miller <[email-masked]>
Date: Tue, 14 Apr 2009 01:55:51 -0700 (PDT)

From: Sachin Sant <[email-masked]>
Date: Tue, 14 Apr 2009 14:10:53 +0530

> Today's next tree build (defconfig s390x ) failed with following
> error.
> 
> In file included from kernel/panic.c:11:
> include/linux/debug_locks.h: In function __debug_locks_off:
> include/linux/debug_locks.h:15: error: implicit declaration of
> function xchg
> 
> Probably because of commit 9eeba6138cefc0435695463ddadb0d95e0a6bcd2.

I see that Stephen fixed this by adding a asm/system.h include
to asm/atomic.h on sparc.

I don't agree with this, and now we have yet another platform
broken in the same way.

If debug_locks.h needs xchg() I think it should include asm/system.h
which was always the traditional location from which to include that
declaration.

It is even the case on x86.

We get it via asm/atomic.h by accident on x86 and other platforms, not
because that's the canonical location from which to get xchg().